/*---------------------------------------------------------
MAIN.C
----------------------------------------------------------*/

#include "includes.h"
#include "STC32G_GPIO.h"
//#include "TASK.h"


/*---------------------------------------------------------
GPIO_config
----------------------------------------------------------*/
void GPIO_config(void)
{
	P0_MODE_IO_PU(GPIO_Pin_All);		//P0 Ϊ׼˫
	P1_MODE_IO_PU(GPIO_Pin_All);		//P1 Ϊ׼˫
	P2_MODE_IO_PU(GPIO_Pin_All);		//P2 Ϊ׼˫
	P3_MODE_IO_PU(GPIO_Pin_All);		//P3 Ϊ׼˫
	P4_MODE_IO_PU(GPIO_Pin_All);		//P4 Ϊ׼˫
	P5_MODE_IO_PU(GPIO_Pin_All);		//P5 Ϊ׼˫
	P6_MODE_IO_PU(GPIO_Pin_All);		//P6 Ϊ׼˫
	P7_MODE_IO_PU(GPIO_Pin_All);		//P7 Ϊ׼˫
	P7_MODE_IO_PU(GPIO_Pin_All);		//P7 Ϊ׼˫
}



#if USE_Extern_Fosc
/*---------------------------------------------------------
ⲿʱӳʼ.  div: ʱӷƵϵ.
----------------------------------------------------------*/
void XOSCClkConfig(u8 div)
{
    P1_MODE_IN_HIZ(GPIO_Pin_7|GPIO_Pin_6);  //GPIO
	XOSCCR = 0xC0;                          //ⲿ
	while (!(XOSCCR & 1));                  //ȴʱȶ
	CLKDIV = div;                           //ʱӷƵ
	CLKSEL = 0x01;                          //ѡⲿ
}
#endif

// ==== ʵʱ ============
void Task_A(void *ddata) ;
void Task_B(void *ddata) ;
void Task_C(void *ddata) ;

// ==== ʵʱջ EDATA ============
unsigned char edata Task_STK_A[512];
unsigned char edata Task_STK_B[512];
unsigned char edata Task_STK_C[512];

// ==== ʱ =============
extern void Test_Delay_MS(unsigned int MS) reentrant;

#define ET2 0x04
#define ET3 0x20
#define ET4 0x40
// ---- ʱ1ʼڲ ----------
#define Timer1_HZ  10000UL	// 10KHz
void Timer1_Init(void)
{
    AUXR |= 0x40;   //ʱʱ1Tģʽ
    TMOD &= 0x0F;   //öʱģʽ
    TL1 =65536 -(MAIN_Fosc / Timer1_HZ);
    TH1 =65536 -(MAIN_Fosc / Timer1_HZ) >> 8;
    TF1 = 0;        //TF1־
    TR1 = 1;        //ʱ1ʼʱ
}

// ---- ʱ3ʼڲ ----------
#define Timer3_HZ  10000UL	// 10KHz

void Timer3_Init(void)
{
    T4T3M &= 0xF0;     //ֹͣ, ʱģʽ, 1Tģʽ, ʱ
    T4T3M |= 0x02;      //ʱʱ1Tģʽ
    T3L =65536 -(MAIN_Fosc / Timer3_HZ);
    T3H =65536 -(MAIN_Fosc / Timer3_HZ) >> 8;
    T4T3M |=  0x08;    //ʼ
}
void Timer1_Handler() interrupt TMR1_VECTOR
{
    OSIntNesting++;     //ϵͳǰܿжϣȻһֱ++

    P26 = ~P26;

    OSIntExit();        //˳ж
}

void Timer3_Handler() interrupt TMR3_VECTOR
{
    OSIntNesting++;     //ϵͳǰܿжϣȻһֱ++

    P27 = ~P27;

    OSIntExit();        //˳ж
}


/*---------------------------------------------------------
main
----------------------------------------------------------*/
void main(void){
	int	i;
	
		WTST = 0;		//óָʱֵΪ0ɽCPUִָٶΪ
		EAXSFR();		//չSFR(XFR)ʹ 
		CKCON = 0;      //߷XRAMٶ
    
    GPIO_config();  //GPIO ʼ
    
    #if USE_Extern_Fosc
        XOSCClkConfig(1);       //лʱ
    #endif
    
// ==== LOGO ============
//			for(;;) {								// ʱ
			for(i=0;i<3;i++) {				// LOGO
				P2=0x00;
				Test_Delay_MS(50);
				P2=0xFF;
				Test_Delay_MS(500);	
			}
    // ==== ʱ1 ʼ ===========
    Timer1_Init();
    ET1 = 1;

//    // ==== ʱ3 ʼ ===========
    Timer3_Init();
    IE2  |=  ET3; 	//ж
    OSInit();		//OSʼ		
		
// ==== uCOS-II  ===============
			OSTaskCreate(Task_A, (void *)0, &Task_STK_A[0],2);
			OSTaskCreate(Task_B, (void *)0, &Task_STK_B[0],3);
			OSTaskCreate(Task_C, (void *)0, &Task_STK_C[0],4);
	
	OSStart();		//ʼ	
    
    while(1);
}





